/**
 * Проверка на сбалансированность фигурных скобкок
 * @param  {string}  input
 * @return {boolean}
 */
function isBalanced(input) {
    const stack = [];
    for (let c of input) {
        if (c === '{') {
            stack.push(c);
        } else if (c === '}') {
            if (stack.pop() !== '{') {
                return false;
            }
        }
    }
    return stack.length === 0;
}

console.log('balanced:', isBalanced('{{}{}}{}')); // true
console.log('not balanced:', isBalanced('{}{{}')); // false
